#include "parameterdump.h"

ParameterDump::ParameterDump(QWidget *parent) :
    QWidget(parent)
{
    this->buildTabParameterDump();

    this->setLayout(layout_parameterDump);
}

void ParameterDump::buildTabParameterDump()
{
    buildCOMM();
    buildNORM();
    buildBURST();
    buildSBM1();
    buildSBM2();

    layout_parameterDump = new QGridLayout();

    layout_parameterDump->addWidget(groupbox_COMM, 0, 0, 1, 1);
    layout_parameterDump->addWidget(groupbox_NORM, 0, 1, 1, 1);
    layout_parameterDump->addWidget(groupbox_BURST, 1, 0, 1, 1);
    layout_parameterDump->addWidget(groupbox_SBM1,2 , 0, 1, 1);
    layout_parameterDump->addWidget(groupbox_SBM2, 2, 1, 1, 1);

    layout_parameterDump->setRowStretch(3, 1);
    layout_parameterDump->setColumnStretch(2, 1);
}

void ParameterDump::buildCOMM()
{
    groupbox_COMM = new QGroupBox(tr("COMMON_PAR"));
    layout_COMM = new QGridLayout();

    sy_lfr_bw = new QLabel("sy_lfr_bw ");
    sy_lfr_sp0 = new QLabel("sy_lfr_sp0 ");
    sy_lfr_sp1 = new QLabel("sy_lfr_sp1 ");
    sy_lfr_r0 = new QLabel("sy_lfr_r0 ");
    sy_lfr_r1 = new QLabel("sy_lfr_r1 ");

    spinbox_sy_lfr_bw = new QSpinBox();
    spinbox_sy_lfr_sp0 = new QSpinBox();
    spinbox_sy_lfr_sp1 = new QSpinBox();
    spinbox_sy_lfr_r0 = new QSpinBox();
    spinbox_sy_lfr_r1 = new QSpinBox();

    spinbox_sy_lfr_bw->setRange(0, 1);
    spinbox_sy_lfr_sp0->setRange(0, 1);
    spinbox_sy_lfr_sp1->setRange(0, 1);
    spinbox_sy_lfr_r0->setRange(0, 1);
    spinbox_sy_lfr_r1->setRange(0, 1);

    spinbox_sy_lfr_bw->setValue(1);
    spinbox_sy_lfr_sp0->setValue(0);
    spinbox_sy_lfr_sp1->setValue(0);
    spinbox_sy_lfr_r0->setValue(0);
    spinbox_sy_lfr_r1->setValue(0);

    layout_COMM->addWidget(sy_lfr_bw, 0, 0, 1, 1);
    layout_COMM->addWidget(sy_lfr_sp0, 1, 0, 1, 1);
    layout_COMM->addWidget(sy_lfr_sp1, 2, 0, 1, 1);
    layout_COMM->addWidget(sy_lfr_r0, 3, 0, 1, 1);
    layout_COMM->addWidget(sy_lfr_r1, 4, 0, 1, 1);

    layout_COMM->addWidget(spinbox_sy_lfr_bw, 0, 1, 1, 1);
    layout_COMM->addWidget(spinbox_sy_lfr_sp0, 1, 1, 1, 1);
    layout_COMM->addWidget(spinbox_sy_lfr_sp1, 2, 1, 1, 1);
    layout_COMM->addWidget(spinbox_sy_lfr_r0, 3, 1, 1, 1);
    layout_COMM->addWidget(spinbox_sy_lfr_r1, 4, 1, 1, 1);

    layout_COMM->setColumnStretch(2, 1);
    layout_COMM->setRowStretch(5, 1);

    groupbox_COMM->setLayout(layout_COMM);
}

void ParameterDump::buildNORM()
{
    groupbox_NORM = new QGroupBox(tr("NORMAL_PAR"));
    layout_NORM = new QGridLayout();

    sy_lfr_n_swf_l = new QLabel("sy_lfr_n_swf_l ");
    sy_lfr_n_swf_p = new QLabel("sy_lfr_n_swf_p ");
    sy_lfr_n_asm_p = new QLabel("sy_lfr_n_asm_p ");
    sy_lfr_n_bp_p0 = new QLabel("sy_lfr_n_bp_p0 ");
    sy_lfr_n_bp_p1 = new QLabel("sy_lfr_n_bp_p1 ");

    spinbox_sy_lfr_n_swf_l = new QSpinBox();
    spinbox_sy_lfr_n_swf_p = new QSpinBox();
    spinbox_sy_lfr_n_asm_p = new QSpinBox();
    spinbox_sy_lfr_n_bp_p0 = new QSpinBox();
    spinbox_sy_lfr_n_bp_p1 = new QSpinBox();

    spinbox_sy_lfr_n_swf_l->setRange(256, 65535);
    spinbox_sy_lfr_n_swf_p->setRange(16, 65535);
    spinbox_sy_lfr_n_asm_p->setRange(16, 65535);
    spinbox_sy_lfr_n_bp_p0->setRange(4, 3600);
    spinbox_sy_lfr_n_bp_p1->setRange(20, 3600);

    spinbox_sy_lfr_n_swf_l->setValue(2048);
    spinbox_sy_lfr_n_swf_p->setValue(300);
    spinbox_sy_lfr_n_asm_p->setValue(3600);
    spinbox_sy_lfr_n_bp_p0->setValue(4);
    spinbox_sy_lfr_n_bp_p1->setValue(20);

    layout_NORM->addWidget(sy_lfr_n_swf_l, 0, 0, 1, 1);
    layout_NORM->addWidget(sy_lfr_n_swf_p, 1, 0, 1, 1);
    layout_NORM->addWidget(sy_lfr_n_asm_p, 2, 0, 1, 1);
    layout_NORM->addWidget(sy_lfr_n_bp_p0, 3, 0, 1, 1);
    layout_NORM->addWidget(sy_lfr_n_bp_p1, 4, 0, 1, 1);

    layout_NORM->addWidget(spinbox_sy_lfr_n_swf_l, 0, 1, 1, 1);
    layout_NORM->addWidget(spinbox_sy_lfr_n_swf_p, 1, 1, 1, 1);
    layout_NORM->addWidget(spinbox_sy_lfr_n_asm_p, 2, 1, 1, 1);
    layout_NORM->addWidget(spinbox_sy_lfr_n_bp_p0, 3, 1, 1, 1);
    layout_NORM->addWidget(spinbox_sy_lfr_n_bp_p1, 4, 1, 1, 1);

    layout_NORM->setColumnStretch(2, 1);
    layout_NORM->setRowStretch(5, 1);

    groupbox_NORM->setLayout(layout_NORM);
}

void ParameterDump::buildBURST()
{
    groupbox_BURST = new QGroupBox(tr("BURST_PAR"));
    layout_BURST = new QGridLayout();

    sy_lfr_b_bp_p0 = new QLabel("sy_lfr_b_bp_p0 ");
    sy_lfr_b_bp_p1 = new QLabel("sy_lfr_b_bp_p1 ");

    spinbox_sy_lfr_b_bp_p0 = new QSpinBox();
    spinbox_sy_lfr_b_bp_p1 = new QSpinBox();

    layout_BURST->addWidget(sy_lfr_b_bp_p0, 0, 0, 1, 1);
    layout_BURST->addWidget(sy_lfr_b_bp_p1, 1, 0, 1, 1);
    layout_BURST->addWidget(spinbox_sy_lfr_b_bp_p0, 0, 1, 1, 1);
    layout_BURST->addWidget(spinbox_sy_lfr_b_bp_p1, 1, 1, 1, 1);

    layout_BURST->setColumnStretch(2, 1);
    layout_BURST->setRowStretch(3, 1);

    groupbox_BURST->setLayout(layout_BURST);
}

void ParameterDump::buildSBM1()
{
    groupbox_SBM1 = new QGroupBox(tr("SBM1_PAR"));
    layout_SBM1 = new QGridLayout();

    sy_lfr_s1_bp_p0 = new QLabel("sy_lfr_s1_bp_p0 ");
    sy_lfr_s1_bp_p1 = new QLabel("sy_lfr_s1_bp_p1 ");

    spinbox_sy_lfr_s1_bp_p0 = new QSpinBox();
    spinbox_sy_lfr_s1_bp_p1 = new QSpinBox();

    layout_SBM1->addWidget(sy_lfr_s1_bp_p0, 0, 0, 1, 1);
    layout_SBM1->addWidget(sy_lfr_s1_bp_p1, 1, 0, 1, 1);
    layout_SBM1->addWidget(spinbox_sy_lfr_s1_bp_p0, 0, 1, 1, 1);
    layout_SBM1->addWidget(spinbox_sy_lfr_s1_bp_p1, 1, 1, 1, 1);

    layout_SBM1->setColumnStretch(2, 1);
    layout_SBM1->setRowStretch(3, 1);

    groupbox_SBM1->setLayout(layout_SBM1);
}

void ParameterDump::buildSBM2()
{
    groupbox_SBM2 = new QGroupBox(tr("SBM2_PAR"));
    layout_SBM2 = new QGridLayout();

    sy_lfr_s2_bp_p0 = new QLabel("sy_lfr_s2_bp_p0 ");
    sy_lfr_s2_bp_p1 = new QLabel("sy_lfr_s2_bp_p1 ");

    spinbox_sy_lfr_s2_bp_p0 = new QSpinBox();
    spinbox_sy_lfr_s2_bp_p1 = new QSpinBox();

    layout_SBM2->addWidget(sy_lfr_s2_bp_p0, 0, 0, 1, 1);
    layout_SBM2->addWidget(sy_lfr_s2_bp_p1, 1, 0, 1, 1);
    layout_SBM2->addWidget(spinbox_sy_lfr_s2_bp_p0, 0, 1, 1, 1);
    layout_SBM2->addWidget(spinbox_sy_lfr_s2_bp_p1, 1, 1, 1, 1);

    layout_SBM2->setColumnStretch(2, 1);
    layout_SBM2->setRowStretch(3, 1);

    groupbox_SBM2->setLayout(layout_SBM2);
}

void ParameterDump::updateParameterDump(TMPacketToRead *tmPacketToRead)
{

    Packet_TM_LFR_PARAMETER_DUMP_t *parameterPacket;

    parameterPacket = (Packet_TM_LFR_PARAMETER_DUMP_t *) tmPacketToRead->Value;

    sy_lfr_bw->setText(" sy_lfr_bw: " + QString::number( (parameterPacket->bw_sp0_sp1_r0_r1 & 0x10 ) >> 4 ) );
    sy_lfr_sp0->setText(" sy_lfr_bw: " + QString::number( (parameterPacket->bw_sp0_sp1_r0_r1 & 0x08 ) >> 3 ) );
    sy_lfr_sp1->setText(" sy_lfr_bw: " + QString::number( (parameterPacket->bw_sp0_sp1_r0_r1 & 0x04 ) >> 2 ) );
    sy_lfr_r0->setText(" sy_lfr_bw: " + QString::number( (parameterPacket->bw_sp0_sp1_r0_r1 & 0x02 ) >> 1 ) );
    sy_lfr_r1->setText(" sy_lfr_bw: " + QString::number( (parameterPacket->bw_sp0_sp1_r0_r1 & 0x01 ) ) );

    sy_lfr_n_swf_l->setText(" sy_lfr_n_swf_l: "
                            + QString::number( parameterPacket->sy_lfr_n_swf_l[0] * 256
                            + parameterPacket->sy_lfr_n_swf_l[1] ) );
    sy_lfr_n_swf_p->setText(" sy_lfr_n_swf_p: "
                            + QString::number( parameterPacket->sy_lfr_n_swf_p[0] * 256
                            + parameterPacket->sy_lfr_n_swf_p[1] ) );
    sy_lfr_n_asm_p->setText(" sy_lfr_n_asm_p: "
                            + QString::number( parameterPacket->sy_lfr_n_asm_p[0] * 256
                            + parameterPacket->sy_lfr_n_asm_p[1] ) );
    sy_lfr_n_bp_p0->setText(" sy_lfr_n_bp_p0: " + QString::number( parameterPacket->sy_lfr_n_bp_p0 ) );
    sy_lfr_n_bp_p1->setText(" sy_lfr_n_bp_p1: " + QString::number( parameterPacket->sy_lfr_n_bp_p1 ) );

    sy_lfr_b_bp_p0->setText(" sy_lfr_b_p0: " + QString::number( parameterPacket->sy_lfr_b_bp_p0 ) );
    sy_lfr_b_bp_p1->setText(" sy_lfr_b_p1: " + QString::number( parameterPacket->sy_lfr_b_bp_p1 ) );

    sy_lfr_s1_bp_p0->setText(" sy_lfr_s1_p0: " + QString::number( parameterPacket->sy_lfr_s1_bp_p0 ) );
    sy_lfr_s1_bp_p1->setText(" sy_lfr_s1_p1: " + QString::number( parameterPacket->sy_lfr_s1_bp_p1 ) );

    sy_lfr_s2_bp_p0->setText(" sy_lfr_s2_p0: " + QString::number( parameterPacket->sy_lfr_s2_bp_p0 ) );
    sy_lfr_s2_bp_p1->setText(" sy_lfr_s2_p1: " + QString::number( parameterPacket->sy_lfr_s2_bp_p1 ) );
}
